import { Plugin, NodeInterface, SchemaInterface, PluginOptions } from '@ctoweb/engine';
import CodeBlockComponent, { CodeBlockValue } from './component';
export interface CodeblockOptions extends PluginOptions {
    hotkey?: string | Array<string>;
    markdown?: boolean;
    alias?: Record<string, string>;
    styleMap?: Record<string, string>;
}
export default class<T extends CodeblockOptions = CodeblockOptions> extends Plugin<T> {
    static get pluginName(): string;
    init(): void;
    execute(mode: string, value: string): void;
    hotkey(): string | string[];
    markdown(event: KeyboardEvent): false | undefined;
    pasteSchema(schema: SchemaInterface): void;
    pasteHtml: (node: NodeInterface) => boolean | undefined;
    checkMarkdownMath: (child: NodeInterface) => boolean;
    checkMarkdown: (node: NodeInterface) => {
        reg: RegExp;
        match: RegExpExecArray | null;
    } | undefined;
    pasteMarkdown: (node: NodeInterface) => void;
    parseHtml: (root: NodeInterface, callback?: ((node: NodeInterface, value: CodeBlockValue) => NodeInterface) | undefined) => NodeInterface[];
    destroy(): void;
}
export { CodeBlockComponent };
export type { CodeBlockValue };
